/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.services.cservices.testcases.scu;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;


import java.io.BufferedReader;
import java.io.InputStreamReader;


import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;

import cdac.medinfo.sdk.dcm30_04.dicommodel.xray.XRayAngiographicIOD;
import cdac.medinfo.sdk.dcm30_04.enums.EnumLoggingLevel;
import cdac.medinfo.sdk.dcm30_04.enums.EnumPDUType;
import cdac.medinfo.sdk.dcm30_04.enums.EnumSOPClassUIDs;

import cdac.medinfo.sdk.dcm30_04.services.association.AAbort;
import cdac.medinfo.sdk.dcm30_04.services.association.AReleaseRQorRP;
import cdac.medinfo.sdk.dcm30_04.services.association.AssociateRQ;
import cdac.medinfo.sdk.dcm30_04.services.association.DefaultAssociation;
import cdac.medinfo.sdk.dcm30_04.services.association.RQPresContext;
import cdac.medinfo.sdk.dcm30_04.services.cstore.commons.CStoreRQ;
import cdac.medinfo.sdk.dcm30_04.services.cstore.commons.CStoreRSP;
import cdac.medinfo.sdk.dcm30_04.services.cstore.scu.CStoreSCU;
import cdac.medinfo.sdk.dcm30_04.services.scu.commons.SCUSession;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.ISingleCollection;
import cdac.medinfo.sdk.dcm30_04.utils.SingleCollection;

/**
 * This class is implemented to test the C-Store SCU.
 * In order to run the following class , please refer to this link($Link) to create the environment.
 * To implement an SCU of a particular we need to do the following things:
 * Create the SCUSession object which maintains the current session of the SCU. Its "start" method accepts
 * the SCP's IP Address and Port and tries to establish a connection with the SCP.
 * 
 * Next step is to establish association .Some ways to create an Association Request: 
 * 1)Use Default Association class to Load the association for requested service. User can load the association 
 * by specifying the Service Type in loadAssociation method of Default association. For e.g. here EnumServiceType.CSTORE
 * should be specified to load Association for C-Store Services. The association request for C-Store 
 * is made according to  jars in the class path.
 * 2) Manually create object of AssociationRQ class and set all presentation contexts collection on it. 
 * More details provided in the API DOCS of AssociationRQ class.
 * 
 * After successful association is established the SCUSession stores the status of the Association with it.  
 * Create CStoreSCU object to send the C-Store Request to the respective SCP. Currently the "sendMessage" method 
 * of the CStoreSCU would wait after sending the C-Store-RQ until a suitable DIMSE response is received. 
 * This operation is part of Synchronous mode request handling.  
 * Once the DIMSE response is received by the CStoreSCU it stores it into its collection
 * which then can be retrieved.
 * 
 * After this, create a A-Release-RQ in order to request for association release and send it using the
 * SCUSession object. This again is a blocking call and the SCUSession waits until a A-Release-RP is received.
 * 
 * At the end of an operation calling "close" on SCUSession would disconnect the connection made with the 
 * SCP and release all the acquired resources.
 * Instead of closing the session after a C-Store operation is complete,we can create another association
 * and send more requests. 
 * Also it is possible to create multiple C-Store-RQs and send them one by one on the same Association.
 */
public class CStore_SCU 
{
	public static void main(String[] args)
	{
		DicomConfig objDicomConfig = DicomConfig.createInstance();

		//enable logging,specify the path of the directory where log files are created.
		//User can specify any directory in place of 'c:\DCM_Logs'.
		//If no directory is defined by user to create logs then it is created in User Temp DIR.
		objDicomConfig.enableLogging(EnumLoggingLevel.INFO, "C:\\DCM_Logs");
		
		/*
		 * Creates instance of CStore_SCU
		 */
		CStore_SCU objTestCStoreSCU = new CStore_SCU();

		/*
		 * Starts C-Store SCU.
		 */
		objTestCStoreSCU.start();
	}

	/**
	 * This function performs the CStore operation.
	 */
	public void start()
	{
		//Current SCU Session
		SCUSession objSession =null;

		try
		{
			//Enter the X-Ray Angiogram DICOM File with full path
			String strFilePath = null;
			System.out.println("Enter the X-Ray Angiogram Dicom File with complete path");
			BufferedReader b_reader =new BufferedReader( new InputStreamReader( System.in ) );
			strFilePath = b_reader.readLine();

			// Creates the object of corresponding IOD by calling its constructor which takes File Name as a parameter and give its DataSet.
			XRayAngiographicIOD objXRayAngiographicIOD = new XRayAngiographicIOD(strFilePath);

			IDataSet objIDataSet = objXRayAngiographicIOD.getDataSet();

			//Create SCUSession object
			objSession = new SCUSession();
			
			/*
			 * Setting time out as 5000 milli second. It will wait 5000 mili seconds for read and write operation.
			 * If in the time specified (5000 ms) read or write operation is not performed then 
			 * session is time out.
			 */ 
			//objSession.setTimeOut(5000);

			/*
			 * Creating RQPresContext for which C-Store is to be performed.
			 */
			ISingleCollection<RQPresContext> objRQPresContextCol = new SingleCollection<RQPresContext>();

			//RQ Pres Context for X-Ray
			RQPresContext objRQPresContextXRay = new RQPresContext();
			objRQPresContextXRay.setAbstractSyntaxName(EnumSOPClassUIDs.XRAYANGIOGRAPHICIOD.getValue());
			objRQPresContextXRay.addTransferSyntax(DicomConstants.TS_LOSSY_JPEG_8_BIT);
			objRQPresContextCol.add(objRQPresContextXRay);

			//RQ Pres Context for CT
			RQPresContext objRQPresContextCT = new RQPresContext();
			objRQPresContextCT.setAbstractSyntaxName(EnumSOPClassUIDs.CTIOD.getValue());
			objRQPresContextCT.addTransferSyntax(DicomConstants.TS_DEFAULT_IMPLICIT_VR_LITTLE_ENDIAN);
			objRQPresContextCol.add(objRQPresContextCT);

			//RQ Pres Context for NM
			RQPresContext objRQPresContextNM = new RQPresContext();
			objRQPresContextNM.setAbstractSyntaxName(EnumSOPClassUIDs.NMIOD.getValue());
			objRQPresContextNM.addTransferSyntax(DicomConstants.TS_DEFAULT_IMPLICIT_VR_LITTLE_ENDIAN);
			objRQPresContextCol.add(objRQPresContextNM);

			//RQ Pres Context for SC
			RQPresContext objRQPresContextSC = new RQPresContext();
			objRQPresContextSC.setAbstractSyntaxName(EnumSOPClassUIDs.SCIOD.getValue());
			objRQPresContextSC.addTransferSyntax(DicomConstants.TS_DEFAULT_IMPLICIT_VR_LITTLE_ENDIAN);
			objRQPresContextCol.add(objRQPresContextSC);

			/*
			 * Load Default Association for RQPresContextProvided.
			 */
			DefaultAssociation objDefaultAssociation = new DefaultAssociation("SDK");
			objDefaultAssociation.loadAssociation(objRQPresContextCol);


			//Create Association RQ
			AssociateRQ objAssociateRQ = objDefaultAssociation.getAssociationRQ("SDK");

			//Start SCU Session by providing the IP address and Port of SCP.
			objSession.start("192.168.8.99", 9000);

			//Create CStore SCU object using the current SCU Session.
			CStoreSCU objCStoreSCU = new CStoreSCU(objSession);

			//Send the Association Request
			if(objSession.sendAssociationMessage(objAssociateRQ))
			{	
				//When association is successfully established the "objSession.sendAssociationMessage()"
				//method returns true.

				System.out.println("Association established");
				//To send multiple RQ use while loop
//				int i = 4;
//				while(i-- > 0)
//				{
//				Parse the DataSet from an existing DICOM file.


				//Create Default CStore RQ by giving the parsed DataSet. This method uses
				// default values for the attributes in the request. These attributes can be
				//modified once the request object is created, before sending.
				CStoreRQ objCStoreRQ = CStoreRQ.getDefaultRQ(objIDataSet);

				System.out.println("CStore Request initialized");

				//Send the C-Store-RQ and wait for a C-Store-RSP.
				//This method exits once the response is received. This response is 
				//added in the response collection maintained by the CStoreSCU which
				//can be retrieved.
				if(objCStoreSCU.sendMessage(objCStoreRQ))
					System.out.println("CStore Response received");
				else
					System.out.println("CStore Operation not performed");

				//Get the Response Size collection from C-Store SCU.
				System.out.println("Response Collection Size ==== " + objCStoreSCU.getDIMSEResponse().size());

				//Printing Status of C-Store Request.
				if(objCStoreSCU.getDIMSEResponse().size() >0)
				{
					CStoreRSP objCStoreRSP = new CStoreRSP(objCStoreSCU.getDIMSEResponse().get(0));
					System.out.println("C-Store Response Status is :" + Integer.toHexString(objCStoreRSP.getStatus()));
				}

				//Create A-Release-RQ to release the association
				AReleaseRQorRP objAReleaseRQorRP = new AReleaseRQorRP(EnumPDUType.RELEASE_RQ);

				//Send the A-Release-RQ
				if(objSession.sendAssociationMessage(objAReleaseRQorRP))
				{
					System.out.println("Association is released");
					//When successful A-Release-RP is received, close the Session.
					//Please note that instead of closing the session we can create 
					//another association and send more requests. Also it is possible
					//to create multiple C-Store-RQs and send them one by one.
					objSession.close();
				}

				//In case an ABORT is received from SCP during the C-Store operation
				if(objSession.getDIMSEAssociation() instanceof AAbort)
				{
					System.out.println("Abort Arrives. Closing SCU session.");
					objSession.close();
				}
			}
			else
			{
				System.out.println("Association cannot be established");
				objSession.close();
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
			objSession.close();
		}
	}
}
